Public Class CResults
  Private m_nResCount As Integer
  Private m_uResRec() As TypeModule.ResType

  Public Sub New()
    m_nResCount = 0
  End Sub

  Public Sub Add(ByVal sModel As String, ByVal fR2 As Double, ByVal fSlope1 As Double, ByVal fSlope2 As Double, ByVal fIntercept As Double, ByVal sErr As String)
    ReDim Preserve m_uResRec(m_nResCount + 1)

    m_uResRec(m_nResCount).m_sModel = sModel
    m_uResRec(m_nResCount).m_fR2 = fR2
    m_uResRec(m_nResCount).m_fSlope1 = fSlope1
    m_uResRec(m_nResCount).m_fSlope2 = fSlope2
    m_uResRec(m_nResCount).m_fIntercept = fIntercept
    m_uResRec(m_nResCount).m_sErr = sErr
    m_nResCount = m_nResCount + 1
  End Sub

  Public Sub Clear()
    m_nResCount = 0
  End Sub

  Public Function Count() As Integer
    Return m_nResCount
  End Function

  Public Function GetModel(ByVal nIndex As Integer) As String
    Return IIf(nIndex > -1 And nIndex < m_nResCount, m_uResRec(nIndex).m_sModel, "")
  End Function

  Public Function GetR2(ByVal nIndex As Integer) As Double
    Return IIf(nIndex > -1 And nIndex < m_nResCount, m_uResRec(nIndex).m_fR2, -1)
  End Function

  Public Function GetSlope1(ByVal nIndex As Integer) As Double
    Return IIf(nIndex > -1 And nIndex < m_nResCount, m_uResRec(nIndex).m_fSlope1, -1.0E+30)
  End Function

  Public Function GetSlope2(ByVal nIndex As Integer) As Double
    Return IIf(nIndex > -1 And nIndex < m_nResCount, m_uResRec(nIndex).m_fSlope2, -1.0E+30)
  End Function

  Public Function GetIntercept(ByVal nIndex As Integer) As Double
    Return IIf(nIndex > -1 And nIndex < m_nResCount, m_uResRec(nIndex).m_fIntercept, -1.0E+30)
  End Function

  Public Function GetErr(ByVal nIndex As Integer) As String
    Return IIf(nIndex > -1 And nIndex < m_nResCount, m_uResRec(nIndex).m_sErr, "")
  End Function

  Public Sub SortResults()
    Dim bInorder As Boolean
    Dim I, J, N, nOffset, nResetCounter As Integer
    Dim uBuffer As TypeModule.ResType

    N = m_nResCount
    nOffset = N
    nResetCounter = 0
    Do
      nOffset = (5 * nOffset) / 11
      If nOffset = 0 Then nOffset = 1
      bInorder = True
      For I = 0 To N - nOffset - 1
        J = I + nOffset
        If m_uResRec(I).m_fR2 < m_uResRec(J).m_fR2 Then
          uBuffer = m_uResRec(I)
          m_uResRec(I) = m_uResRec(J)
          m_uResRec(J) = uBuffer
          bInorder = False
        End If
      Next
      If bInorder Then nResetCounter += 1
      If (Not bInorder) And (nOffset = 1) Then
        nOffset = N
        For I = 1 To nResetCounter
          nOffset = (5 * nOffset) / 11
        Next
        If nOffset = 0 Then nOffset = 1
      End If
    Loop Until nOffset = 1 And bInorder
  End Sub
End Class
